/* filehelper.c generated by valac 0.20.1.54-6d076, the Vala compiler
 * generated from filehelper.vala, do not modify */

/* filehelper.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Brosch Florian <flo.brosch@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>

#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean valadoc_copy_file (const gchar* src, const gchar* dest);
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest);
gboolean valadoc_remove_directory (const gchar* rpath);
gboolean valadoc_ends_with_dir_separator (const gchar* s);
gchar* valadoc_realpath (const gchar* name);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Makes a copy of the file src to dest. 
 *
 * @param src the file to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_file (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	FILE* fsrc = NULL;
	const gchar* _tmp0_ = NULL;
	FILE* _tmp1_ = NULL;
	FILE* _tmp2_ = NULL;
	FILE* fdest = NULL;
	const gchar* _tmp3_ = NULL;
	FILE* _tmp4_ = NULL;
	FILE* _tmp5_ = NULL;
	g_return_val_if_fail (src != NULL, FALSE);
	g_return_val_if_fail (dest != NULL, FALSE);
	_tmp0_ = src;
	_tmp1_ = g_fopen (_tmp0_, "rb");
	fsrc = _tmp1_;
	_tmp2_ = fsrc;
	if (_tmp2_ == NULL) {
		result = FALSE;
		_fclose0 (fsrc);
		return result;
	}
	_tmp3_ = dest;
	_tmp4_ = g_fopen (_tmp3_, "wb");
	fdest = _tmp4_;
	_tmp5_ = fdest;
	if (_tmp5_ == NULL) {
		result = FALSE;
		_fclose0 (fdest);
		_fclose0 (fsrc);
		return result;
	}
	{
		gint c = 0;
		FILE* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		_tmp6_ = fsrc;
		_tmp7_ = fgetc (_tmp6_);
		c = _tmp7_;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gboolean _tmp9_ = FALSE;
				FILE* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				FILE* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				_tmp9_ = _tmp8_;
				if (!_tmp9_) {
					FILE* _tmp10_ = NULL;
					gint _tmp11_ = 0;
					_tmp10_ = fsrc;
					_tmp11_ = fgetc (_tmp10_);
					c = _tmp11_;
				}
				_tmp8_ = FALSE;
				_tmp12_ = fsrc;
				_tmp13_ = feof (_tmp12_);
				if (!(!_tmp13_)) {
					break;
				}
				_tmp14_ = fdest;
				_tmp15_ = c;
				fputc ((gchar) _tmp15_, _tmp14_);
			}
		}
	}
	result = TRUE;
	_fclose0 (fdest);
	_fclose0 (fsrc);
	return result;
}


/**
 * Makes a copy of the directory src to dest. 
 *
 * @param src the directory to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* _src = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gchar* _dest = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (src != NULL, FALSE);
	g_return_val_if_fail (dest != NULL, FALSE);
	_tmp1_ = src;
	_tmp2_ = g_str_has_suffix (_tmp1_, "/");
	if (_tmp2_) {
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp3_ = src;
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = src;
		_tmp6_ = g_strconcat (_tmp5_, "/", NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp6_;
	}
	_tmp7_ = _tmp0_;
	_tmp8_ = g_strdup (_tmp7_);
	_src = _tmp8_;
	_tmp10_ = dest;
	_tmp11_ = g_str_has_suffix (_tmp10_, "/");
	if (_tmp11_) {
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		_tmp12_ = dest;
		_tmp13_ = g_strdup (_tmp12_);
		_g_free0 (_tmp9_);
		_tmp9_ = _tmp13_;
	} else {
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		_tmp14_ = dest;
		_tmp15_ = g_strconcat (_tmp14_, "/", NULL);
		_g_free0 (_tmp9_);
		_tmp9_ = _tmp15_;
	}
	_tmp16_ = _tmp9_;
	_tmp17_ = g_strdup (_tmp16_);
	_dest = _tmp17_;
	{
		GDir* dir = NULL;
		const gchar* _tmp18_ = NULL;
		GDir* _tmp19_ = NULL;
		_tmp18_ = _src;
		_tmp19_ = g_dir_open (_tmp18_, (guint) 0, &_inner_error_);
		dir = _tmp19_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch0_g_file_error;
			}
			_g_free0 (_dest);
			_g_free0 (_tmp9_);
			_g_free0 (_src);
			_g_free0 (_tmp0_);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		{
			const gchar* name = NULL;
			GDir* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			_tmp20_ = dir;
			_tmp21_ = g_dir_read_name (_tmp20_);
			name = _tmp21_;
			{
				gboolean _tmp22_ = FALSE;
				_tmp22_ = TRUE;
				while (TRUE) {
					gboolean _tmp23_ = FALSE;
					const gchar* _tmp26_ = NULL;
					const gchar* _tmp27_ = NULL;
					const gchar* _tmp28_ = NULL;
					gchar* _tmp29_ = NULL;
					gchar* _tmp30_ = NULL;
					const gchar* _tmp31_ = NULL;
					const gchar* _tmp32_ = NULL;
					gchar* _tmp33_ = NULL;
					gchar* _tmp34_ = NULL;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
					_tmp23_ = _tmp22_;
					if (!_tmp23_) {
						GDir* _tmp24_ = NULL;
						const gchar* _tmp25_ = NULL;
						_tmp24_ = dir;
						_tmp25_ = g_dir_read_name (_tmp24_);
						name = _tmp25_;
					}
					_tmp22_ = FALSE;
					_tmp26_ = name;
					if (!(_tmp26_ != NULL)) {
						break;
					}
					_tmp27_ = _src;
					_tmp28_ = name;
					_tmp29_ = g_strconcat (_tmp27_, _tmp28_, NULL);
					_tmp30_ = _tmp29_;
					_tmp31_ = _dest;
					_tmp32_ = name;
					_tmp33_ = g_strconcat (_tmp31_, _tmp32_, NULL);
					_tmp34_ = _tmp33_;
					_tmp35_ = valadoc_copy_file (_tmp30_, _tmp34_);
					_tmp36_ = !_tmp35_;
					_g_free0 (_tmp34_);
					_g_free0 (_tmp30_);
					if (_tmp36_) {
						result = FALSE;
						_g_dir_close0 (dir);
						_g_free0 (_dest);
						_g_free0 (_tmp9_);
						_g_free0 (_src);
						_g_free0 (_tmp0_);
						return result;
					}
				}
			}
		}
		_g_dir_close0 (dir);
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* err = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (err);
		_g_free0 (_dest);
		_g_free0 (_tmp9_);
		_g_free0 (_src);
		_g_free0 (_tmp0_);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_free0 (_dest);
		_g_free0 (_tmp9_);
		_g_free0 (_src);
		_g_free0 (_tmp0_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	_g_free0 (_dest);
	_g_free0 (_tmp9_);
	_g_free0 (_src);
	_g_free0 (_tmp0_);
	return result;
}


/**
 * A recursive directory delete function
 *
 * @param rpath the directory to remove
 */
gboolean valadoc_remove_directory (const gchar* rpath) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (rpath != NULL, FALSE);
	{
		GDir* dir = NULL;
		const gchar* _tmp0_ = NULL;
		GDir* _tmp1_ = NULL;
		GDir* _tmp2_ = NULL;
		_tmp0_ = rpath;
		_tmp1_ = g_dir_open (_tmp0_, (guint) 0, &_inner_error_);
		dir = _tmp1_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch1_g_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp2_ = dir;
		if (_tmp2_ == NULL) {
			result = FALSE;
			_g_dir_close0 (dir);
			return result;
		}
		{
			const gchar* entry = NULL;
			GDir* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			_tmp3_ = dir;
			_tmp4_ = g_dir_read_name (_tmp3_);
			entry = _tmp4_;
			{
				gboolean _tmp5_ = FALSE;
				_tmp5_ = TRUE;
				while (TRUE) {
					gboolean _tmp6_ = FALSE;
					const gchar* _tmp9_ = NULL;
					gchar* path = NULL;
					const gchar* _tmp10_ = NULL;
					const gchar* _tmp11_ = NULL;
					gchar* _tmp12_ = NULL;
					gboolean is_dir = FALSE;
					const gchar* _tmp13_ = NULL;
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_ = FALSE;
					_tmp6_ = _tmp5_;
					if (!_tmp6_) {
						GDir* _tmp7_ = NULL;
						const gchar* _tmp8_ = NULL;
						_tmp7_ = dir;
						_tmp8_ = g_dir_read_name (_tmp7_);
						entry = _tmp8_;
					}
					_tmp5_ = FALSE;
					_tmp9_ = entry;
					if (!(_tmp9_ != NULL)) {
						break;
					}
					_tmp10_ = rpath;
					_tmp11_ = entry;
					_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
					path = _tmp12_;
					_tmp13_ = path;
					_tmp14_ = g_file_test (_tmp13_, G_FILE_TEST_IS_DIR);
					is_dir = _tmp14_;
					_tmp15_ = is_dir;
					if (_tmp15_ == TRUE) {
						gboolean tmp = FALSE;
						const gchar* _tmp16_ = NULL;
						gboolean _tmp17_ = FALSE;
						gboolean _tmp18_ = FALSE;
						_tmp16_ = path;
						_tmp17_ = valadoc_remove_directory (_tmp16_);
						tmp = _tmp17_;
						_tmp18_ = tmp;
						if (_tmp18_ == FALSE) {
							result = FALSE;
							_g_free0 (path);
							_g_dir_close0 (dir);
							return result;
						}
					} else {
						gint tmp = 0;
						const gchar* _tmp19_ = NULL;
						gint _tmp20_ = 0;
						gint _tmp21_ = 0;
						_tmp19_ = path;
						_tmp20_ = g_unlink (_tmp19_);
						tmp = _tmp20_;
						_tmp21_ = tmp;
						if (_tmp21_ > 0) {
							result = FALSE;
							_g_free0 (path);
							_g_dir_close0 (dir);
							return result;
						}
					}
					_g_free0 (path);
				}
			}
		}
		_g_dir_close0 (dir);
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* err = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (err);
		return result;
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_ = 0L;
	gunichar _tmp1_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = index;
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
	result = _tmp1_;
	return result;
}


inline gboolean valadoc_ends_with_dir_separator (const gchar* s) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gunichar _tmp4_ = 0U;
	gboolean _tmp5_ = FALSE;
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp0_ = s;
	_tmp1_ = s;
	_tmp2_ = strlen (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_get_char (_tmp0_, (glong) (_tmp3_ - 1));
	_tmp5_ = G_IS_DIR_SEPARATOR (_tmp4_);
	result = _tmp5_;
	return result;
}


/**
 * Returns canonicalized absolute pathname
 *
 * @param name the path being checked
 * @return a canonicalized absolute pathname
 */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


gchar* valadoc_realpath (const gchar* name) {
	gchar* result = NULL;
	gchar* rpath = NULL;
	const gchar* start = NULL;
	const gchar* end = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	glong root_len = 0L;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gboolean _tmp72_ = FALSE;
	const gchar* _tmp73_ = NULL;
	gint _tmp74_ = 0;
	gint _tmp75_ = 0;
	glong _tmp76_ = 0L;
	gboolean _tmp79_ = FALSE;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = g_path_is_absolute (_tmp0_);
	if (!_tmp1_) {
		gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		_tmp2_ = g_get_current_dir ();
		_g_free0 (rpath);
		rpath = _tmp2_;
		_tmp3_ = name;
		end = _tmp3_;
		_tmp4_ = end;
		start = _tmp4_;
	} else {
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		_tmp5_ = name;
		_tmp6_ = g_path_skip_root (_tmp5_);
		end = _tmp6_;
		_tmp7_ = end;
		start = _tmp7_;
		_tmp8_ = name;
		_tmp9_ = start;
		_tmp10_ = name;
		_tmp11_ = string_substring (_tmp8_, (glong) 0, (glong) ((gint) (((gchar*) _tmp9_) - ((gchar*) _tmp10_))));
		_g_free0 (rpath);
		rpath = _tmp11_;
	}
	_tmp12_ = rpath;
	_tmp13_ = g_path_skip_root (_tmp12_);
	_tmp14_ = rpath;
	root_len = (glong) (((gchar*) _tmp13_) - ((gchar*) _tmp14_));
	{
		gboolean _tmp15_ = FALSE;
		_tmp15_ = TRUE;
		while (TRUE) {
			gboolean _tmp16_ = FALSE;
			const gchar* _tmp18_ = NULL;
			gunichar _tmp19_ = 0U;
			glong len = 0L;
			glong _tmp38_ = 0L;
			_tmp16_ = _tmp15_;
			if (!_tmp16_) {
				const gchar* _tmp17_ = NULL;
				_tmp17_ = end;
				start = _tmp17_;
			}
			_tmp15_ = FALSE;
			_tmp18_ = start;
			_tmp19_ = string_get_char (_tmp18_, (glong) 0);
			if (!(_tmp19_ != ((gunichar) 0))) {
				break;
			}
			while (TRUE) {
				const gchar* _tmp20_ = NULL;
				gunichar _tmp21_ = 0U;
				gboolean _tmp22_ = FALSE;
				const gchar* _tmp23_ = NULL;
				const gchar* _tmp24_ = NULL;
				_tmp20_ = start;
				_tmp21_ = string_get_char (_tmp20_, (glong) 0);
				_tmp22_ = G_IS_DIR_SEPARATOR (_tmp21_);
				if (!_tmp22_) {
					break;
				}
				_tmp23_ = start;
				_tmp24_ = g_utf8_next_char (_tmp23_);
				start = _tmp24_;
			}
			len = (glong) 0;
			{
				const gchar* _tmp25_ = NULL;
				gboolean _tmp26_ = FALSE;
				_tmp25_ = start;
				end = _tmp25_;
				_tmp26_ = TRUE;
				while (TRUE) {
					gboolean _tmp27_ = FALSE;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_ = NULL;
					gunichar _tmp32_ = 0U;
					gboolean _tmp36_ = FALSE;
					glong _tmp37_ = 0L;
					_tmp27_ = _tmp26_;
					if (!_tmp27_) {
						const gchar* _tmp28_ = NULL;
						const gchar* _tmp29_ = NULL;
						_tmp28_ = end;
						_tmp29_ = g_utf8_next_char (_tmp28_);
						end = _tmp29_;
					}
					_tmp26_ = FALSE;
					_tmp31_ = end;
					_tmp32_ = string_get_char (_tmp31_, (glong) 0);
					if (_tmp32_ != ((gunichar) 0)) {
						const gchar* _tmp33_ = NULL;
						gunichar _tmp34_ = 0U;
						gboolean _tmp35_ = FALSE;
						_tmp33_ = end;
						_tmp34_ = string_get_char (_tmp33_, (glong) 0);
						_tmp35_ = G_IS_DIR_SEPARATOR (_tmp34_);
						_tmp30_ = !_tmp35_;
					} else {
						_tmp30_ = FALSE;
					}
					_tmp36_ = _tmp30_;
					if (!_tmp36_) {
						break;
					}
					_tmp37_ = len;
					len = _tmp37_ + 1;
				}
			}
			_tmp38_ = len;
			if (_tmp38_ == ((glong) 0)) {
				break;
			} else {
				gboolean _tmp39_ = FALSE;
				glong _tmp40_ = 0L;
				gboolean _tmp43_ = FALSE;
				_tmp40_ = len;
				if (_tmp40_ == ((glong) 1)) {
					const gchar* _tmp41_ = NULL;
					gunichar _tmp42_ = 0U;
					_tmp41_ = start;
					_tmp42_ = string_get_char (_tmp41_, (glong) 0);
					_tmp39_ = _tmp42_ == ((gunichar) '.');
				} else {
					_tmp39_ = FALSE;
				}
				_tmp43_ = _tmp39_;
				if (_tmp43_) {
				} else {
					gboolean _tmp44_ = FALSE;
					glong _tmp45_ = 0L;
					gboolean _tmp48_ = FALSE;
					_tmp45_ = len;
					if (_tmp45_ == ((glong) 2)) {
						const gchar* _tmp46_ = NULL;
						gboolean _tmp47_ = FALSE;
						_tmp46_ = start;
						_tmp47_ = g_str_has_prefix (_tmp46_, "..");
						_tmp44_ = _tmp47_;
					} else {
						_tmp44_ = FALSE;
					}
					_tmp48_ = _tmp44_;
					if (_tmp48_) {
						const gchar* _tmp49_ = NULL;
						gint _tmp50_ = 0;
						gint _tmp51_ = 0;
						glong _tmp52_ = 0L;
						_tmp49_ = rpath;
						_tmp50_ = strlen (_tmp49_);
						_tmp51_ = _tmp50_;
						_tmp52_ = root_len;
						if (((glong) _tmp51_) > _tmp52_) {
							{
								gboolean _tmp53_ = FALSE;
								_tmp53_ = TRUE;
								while (TRUE) {
									gboolean _tmp54_ = FALSE;
									const gchar* _tmp57_ = NULL;
									const gchar* _tmp58_ = NULL;
									gint _tmp59_ = 0;
									gint _tmp60_ = 0;
									gchar* _tmp61_ = NULL;
									_tmp54_ = _tmp53_;
									if (!_tmp54_) {
										const gchar* _tmp55_ = NULL;
										gboolean _tmp56_ = FALSE;
										_tmp55_ = rpath;
										_tmp56_ = valadoc_ends_with_dir_separator (_tmp55_);
										if (!(!_tmp56_)) {
											break;
										}
									}
									_tmp53_ = FALSE;
									_tmp57_ = rpath;
									_tmp58_ = rpath;
									_tmp59_ = strlen (_tmp58_);
									_tmp60_ = _tmp59_;
									_tmp61_ = string_substring (_tmp57_, (glong) 0, (glong) (_tmp60_ - 1));
									_g_free0 (rpath);
									rpath = _tmp61_;
								}
							}
						}
					} else {
						const gchar* _tmp62_ = NULL;
						gboolean _tmp63_ = FALSE;
						const gchar* _tmp66_ = NULL;
						const gchar* _tmp67_ = NULL;
						glong _tmp68_ = 0L;
						gchar* _tmp69_ = NULL;
						gchar* _tmp70_ = NULL;
						gchar* _tmp71_ = NULL;
						_tmp62_ = rpath;
						_tmp63_ = valadoc_ends_with_dir_separator (_tmp62_);
						if (!_tmp63_) {
							const gchar* _tmp64_ = NULL;
							gchar* _tmp65_ = NULL;
							_tmp64_ = rpath;
							_tmp65_ = g_strconcat (_tmp64_, G_DIR_SEPARATOR_S, NULL);
							_g_free0 (rpath);
							rpath = _tmp65_;
						}
						_tmp66_ = rpath;
						_tmp67_ = start;
						_tmp68_ = len;
						_tmp69_ = string_substring (_tmp67_, (glong) 0, _tmp68_);
						_tmp70_ = _tmp69_;
						_tmp71_ = g_strconcat (_tmp66_, _tmp70_, NULL);
						_g_free0 (rpath);
						rpath = _tmp71_;
						_g_free0 (_tmp70_);
					}
				}
			}
		}
	}
	_tmp73_ = rpath;
	_tmp74_ = strlen (_tmp73_);
	_tmp75_ = _tmp74_;
	_tmp76_ = root_len;
	if (((glong) _tmp75_) > _tmp76_) {
		const gchar* _tmp77_ = NULL;
		gboolean _tmp78_ = FALSE;
		_tmp77_ = rpath;
		_tmp78_ = valadoc_ends_with_dir_separator (_tmp77_);
		_tmp72_ = _tmp78_;
	} else {
		_tmp72_ = FALSE;
	}
	_tmp79_ = _tmp72_;
	if (_tmp79_) {
		const gchar* _tmp80_ = NULL;
		const gchar* _tmp81_ = NULL;
		gint _tmp82_ = 0;
		gint _tmp83_ = 0;
		gchar* _tmp84_ = NULL;
		_tmp80_ = rpath;
		_tmp81_ = rpath;
		_tmp82_ = strlen (_tmp81_);
		_tmp83_ = _tmp82_;
		_tmp84_ = string_substring (_tmp80_, (glong) 0, (glong) (_tmp83_ - 1));
		_g_free0 (rpath);
		rpath = _tmp84_;
	}
	if (G_DIR_SEPARATOR != '/') {
		gchar** components = NULL;
		const gchar* _tmp85_ = NULL;
		gchar** _tmp86_ = NULL;
		gchar** _tmp87_ = NULL;
		gint components_length1 = 0;
		gint _components_size_ = 0;
		gchar** _tmp88_ = NULL;
		gint _tmp88__length1 = 0;
		gchar* _tmp89_ = NULL;
		_tmp85_ = rpath;
		_tmp87_ = _tmp86_ = g_strsplit (_tmp85_, "\\", 0);
		components = _tmp87_;
		components_length1 = _vala_array_length (_tmp86_);
		_components_size_ = components_length1;
		_tmp88_ = components;
		_tmp88__length1 = components_length1;
		_tmp89_ = g_strjoinv ("/", _tmp88_);
		_g_free0 (rpath);
		rpath = _tmp89_;
		components = (_vala_array_free (components, components_length1, (GDestroyNotify) g_free), NULL);
	}
	result = rpath;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



